<template>
    <section class="section-sm">
        <div class="container">

            <div class="col-md-12">
                <div class="category-search-filter">
                    <div class="row">
                        <div class="col-md-6">
                            <strong>Short</strong>
                            <select class="nice-select" v-model="order" @change="onChange()">
                                <option value="asc">Lowest Price</option>
                                <option value="desc">Highest Price</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="product-grid-list">
                    <div class="row mt-30">
                        <div class="col-sm-12 col-lg-3 col-md-6" v-for="item in arrayItems" :key="item.id">
                            <!-- product card -->
                            <div class="product-item bg-light">
                                <div class="card">

                                    <div class="thumb-content">
                                        <img class="card-img-top img-fluid" :src="base_url +'/storage/images/'+ item.image" alt="Card image cap">
                                    </div>

                                    <div class="card-body">
                                        <h4 class="card-title"></h4>
                                        <span v-if="item.max_bid > 0" class="list-inline-item" style="color: red!important">
                                            Max Bid: ${{item.max_bid}}
                                        </span>
                                        <span class="list-inline-item" style="color: gray!important; font-size: 15px !important">
                                            Opening price: ${{item.starting_price}}
                                        </span>
                                        <div class="product-ratings">
                                            <span class="list-inline-item" style="font-size: 15px!important; font-weight: bold !important; margin-top:10px !important;">
                                                Bids: {{item.history}}
                                            </span>
                                        </div>
                                        <span class="list-inline-item" style="font-size: 15px!important; font-weight: bold !important; margin-top:10px !important;">
                                            Close: {{item.deadline}}
                                        </span>
                                        <!--
                                        <count-down :date="item.deadline"></count-down>
                                        -->
                                    </div>

                                    <button class="btn btn-outline-secondary" @click="BidNow(item.id)" type="button">Bid Now</button>

                                </div>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="pagination justify-content-center">

                    <nav aria-label="Page navigation example">
                        <ul class="pagination">
                            <li class="page-item" v-if="pagination.current_page > 1">
                                <a class="page-link" href="#" @click.prevent="nextpage(pagination.current_page - 1)">Prev</a>
                            </li>
                            <li class="page-item" v-for="page in pagesNumber" :key="page" :class="[page == isActived ? 'active' : '']">
                                <a class="page-link" href="#" @click.prevent="nextpage(page)" v-text="page"></a>
                            </li>
                            <li class="page-item" v-if="pagination.current_page < pagination.last_page">
                                <a class="page-link" href="#" @click.prevent="nextpage(pagination.current_page + 1)">Next</a>
                            </li>
                        </ul>
                    </nav>

                </div>
            </div>

        </div>
    </section>
</template>

<script>
import CountDown from './Layouts/CountDown';

export default {
    props: {
       search: {type: String, default: ''},
       page: {type: Number, default: 1}
    },
    components: {
        'count-down': CountDown
    },
    computed: {

	},
    data () {
        return {
            arrayItems: [],

            pagination : {
                'total' : 0,
                'current_page' : 0,
                'per_page' : 0,
                'last_page' : 0,
                'from' : 0,
                'to' : 0,
            },
            offset : 3,
            sort: 'starting_price',
            order: 'asc',
            base_url: window.location.origin
        }
    },
    computed:{
        isActived: function(){
            return this.pagination.current_page;
        },
        //Calcula los elementos de la paginación
        pagesNumber: function() {
            if(!this.pagination.to) {
                return [];
            }

            var from = this.pagination.current_page - this.offset;
            if(from < 1) {
                from = 1;
            }

            var to = from + (this.offset * 2);
            if(to >= this.pagination.last_page){
                to = this.pagination.last_page;
            }

            var pagesArray = [];
            while(from <= to) {
                pagesArray.push(from);
                from++;
            }
            return pagesArray;

        }
    },
    methods: {
        list(page){
            let me=this;
            var url = '/articles?page=' + page + '&sort=' + me.sort + '&order=' + me.order +'&search=' + me.search;
            axios.get(url)
            .then(function (response) {
                console.log(response);
                me.arrayItems = response.data.articles.data;
                me.pagination= response.data.pagination;
            })
            .catch(function (error) {
                console.log(error);
            });
        },
        nextpage(page){

            //var url = '/articles/page_'+ page;

            let me = this;
            //Actualiza la página actual
            me.pagination.current_page = page;
            //Envia la petición para visualizar la data de esa página
            me.list(page);

            //window.location.href = url;
        },
        onChange(event) {
            console.log('Cambiando:' + this.order);
            this.list(1);
        },
        BidNow(item){
            window.location.href = '/articles/' + item;
        } ,

    },
    created: function() {
       this.list(1);

    }

}
</script>

<style scoped>
   .nice-select {
    -webkit-tap-highlight-color: transparent;
    background-color: #fff;
    border-radius: 5px;
    border: solid 1px #e8e8e8;
    box-sizing: border-box;
    clear: both;
    cursor: pointer;
    display: inline-block;
    float: none;
    font-family: inherit;
    font-size: 14px;
    font-weight: normal;
    height: 42px;
    line-height: 40px;
    outline: none;
    padding-left: 18px;
    padding-right: 30px;
    position: relative;
    text-align: left !important;
    transition: all 0.2s ease-in-out;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    white-space: nowrap;
    width: auto;
}

</style>
